;-----------------------------------------------------------------------
;               ubN̕ҏW  Ver 1.10
;               Bedit.lsp                     2000/12/08          J.Sato
;-----------------------------------------------------------------------
(defun c:Bedit (/ loc_data set_data get_data se sx sy sz sc ang sa rn rp
                  gn gp tbl sellist name dcl_id what_next ent n dimzin
                  Blklist sdata flist dlist ep sp ents dm)

(setq m:err *error*)

(defun *error* (msg)
  (princ msg)
  (setvar "dimzin" dimzin)
  (setq *error* m:err m:err nil)
  (princ)
)

; Xy[X؂̕񂩂烊Xg쐬B--------------------------

(defun make_list (string / rdata dat a)
  (setq rdata nil)
  (while (setq dat (read string))
    (setq a 1)
    (while (= " " (substr string a 1))
      (setq a (1+ a))
    )
    (while (and (/= " " (substr string a 1)) 
                (/= ""  (substr string a 1)))
      (setq a (1+ a))
    )
    (setq rdata  (append rdata (list dat))
          string (substr string a)
    )
  )
  rdata
)

; Xg{bNX̃Zbgf[^쐬B------------------------------

(defun list_all (n / sel sp)
; n       Xgo[̐
  (setq sel "" sp 0)
  (while (< sp n)
    (setq sel (strcat sel " " (itoa sp))
          sp  (1+ sp)
    )
  )
  (substr sel 2)
)

(defun list_reverse (key n / alist slist tlist hlist a sel)
; key     Xg{bNX̃L[
; n       Xgo[̐
  (setq alist (make_list (list_all n))
        slist (make_list (get_tile key))
        sel ""
  )
  (foreach a slist
    (setq tlist (cdr (member a alist))
          hlist (cdr (member a (reverse alist)))
          alist (append (reverse hlist) tlist)
    )
  )
  (foreach a alist
    (setq sel (strcat sel " " (itoa a)))
  )
  (substr sel 2)
)

; XYZ ̃XP[𓯂ɂƂ̃ANV ---------------------------

(defun loc_data ( / dm)
  (setq se (atoi (get_tile "se")))
  (if (= 1 se)
    (progn
      (setq dm (get_tile "sx"))
      (if (numberp (read dm))
        (progn
          (set_tile "sy" dm) (mode_tile "sy" 1)
          (set_tile "sz" dm) (mode_tile "sz" 1)
          (set_tile "sc_note" "")
        )
        (progn
          (set_tile "sc_note" "قɂ͐l͂̂")
          (mode_tile "sx" 2)
        )
      )
    )
    (progn
      (mode_tile "sy" 0)
      (mode_tile "sz" 0)
    )
  )
)

; _CAÕf[^ăZbg -------------------------------------

(defun set_data ()
  (set_tile "blist" (if sdata sdata ""))
  (set_tile "sx"  (if sx  (rtos sx)  ""))
  (set_tile "sy"  (if sy  (rtos sy)  ""))
  (set_tile "sz"  (if sz  (rtos sz)  ""))
  (set_tile "sc"  (if sc sc "0"))
  (set_tile "ang" (if ang (rtos ang) ""))
  (set_tile "sa"  (if sa sa "0"))
  (set_tile "rn"  (if rn  (itoa rn)  ""))
  (set_tile "rp"  (if rp  (rtos rp)  ""))
  (set_tile "gn"  (if gn  (itoa gn)  ""))
  (set_tile "gp"  (if gp  (rtos gp)  ""))
)

; _CAOf[^Ƃ肾 ---------------------------------------

(defun get_data ( / dm)
  (setq sdata (get_tile "blist")
        dm    (read (get_tile "sx"))
        sx    (if (numberp dm) (float dm) nil)
        dm    (read (get_tile "sy"))
        sy    (if (numberp dm) (float dm) nil)
        dm    (read (get_tile "sz"))
        sz    (if (numberp dm) (float dm) nil)
        sc    (get_tile "sc")
        dm    (read (get_tile "ang"))
        ang   (if (numberp dm) (float dm) nil)
        sa    (get_tile "sa")
        dm    (read (get_tile "rn"))
        rn    (if (numberp dm) (fix dm) nil)
        dm    (read (get_tile "rp"))
        rp    (if (numberp dm) (float dm) nil)
        dm    (read (get_tile "gn"))
        gn    (if (numberp dm) (fix dm) nil)
        dm    (read (get_tile "gp"))
        gp    (if (numberp dm) (float dm) nil)
  )
)

; lۑ -----------------------------------------------------------

  (setq dimzin (getvar "dimzin"))
  (setvar "dimzin" 8)

; ubNXg쐬 ---------------------------------------------------

  (setq ents (ssget "x" '((0 . "insert"))))

  (if (= nil ents)
    (progn
      (princ "\ngp̃ubN͂܂B\n")
      (exit)
    )
  )

  (setq sp      0
        ep      (sslength ents)
        sellist nil
  )

  (while (< sp ep)
    (setq ent     (entget (ssname ents sp))
          name    (cdr (assoc 2 ent))
          sellist (cons name sellist)
          sp      (1+ sp)
    )
  )

  (setq sub_list (acad_strlsort sellist)
        sellist  nil
  )

  (while sub_list
    (setq name    (car sub_list))
    (if (/= "*" (substr name 1 1))
      (setq sellist (append sellist (list name)))
    )
    (while (= name (car (setq sub_list (cdr sub_list)))))
  )

  (setq n (length sellist))

; _CAOZbg -----------------------------------------------------

  (setq dcl_id (load_dialog "Bedit.dcl")
        what_next 10)
  (if (< dcl_id 0) (exit))

  (while (< 1 what_next)

    (new_dialog "Bedit" dcl_id)

    (start_list "blist")
    (mapcar 'add_list sellist)
    (end_list)

    (if (and (<= 2 what_next) (>= 6 what_next)) (set_data))

    (action_tile "a" "(set_tile \"blist\" (list_all n))")
    (action_tile "c" "(set_tile \"blist\" \"\")")
    (action_tile "r"
      (strcat
        "(setq sel (list_reverse \"blist\" n))"
        "(set_tile \"blist\" \"\")"
        "(set_tile \"blist\" sel)"
      )
    )

    (action_tile "se" "(loc_data)")
    (action_tile "sx" "(if (= 1 $reason) (loc_data))")
    (action_tile "accept" "(get_data)(done_dialog)")
    (action_tile "cancel" "(done_dialog)(exit)")
    (action_tile "d"      "(done_dialog 2)")
    (action_tile "rc"     "(get_data)(done_dialog 3)")
    (action_tile "gc"     "(get_data)(done_dialog 4)")
    (action_tile "ac"     "(get_data)(done_dialog 5)")
    (action_tile "p"      "(get_data)(done_dialog 6)")
    (setq what_next (start_dialog))

    (cond
      ((= 2 what_next)
        (setq ent (entget (car (entsel "\nQƃIuWFNg:"))))
        (if (= (cdr (assoc 0 ent)) "INSERT")
          (progn
            (setq name  (cdr (assoc 2 ent))
                  sdata (itoa (- n (length (member name sellist))))
                  sx    (cdr (assoc 41 ent))
                  sy    (cdr (assoc 42 ent))
                  sz    (cdr (assoc 43 ent))
                  ang   (* 180 (/ (cdr (assoc 50 ent)) pi))
                  rn    (cdr (assoc 70 ent))
                  rp    (cdr (assoc 44 ent))
                  gn    (cdr (assoc 71 ent))
                  gp    (cdr (assoc 45 ent))
            )
          ) ; progn end
          (princ "\nubNł͂܂\n")
        ) ; if end
      )
      ((or (= 3 what_next) (= 4 what_next) (= 5 what_next))
        (setq p1  (getpoint    "\n1st point:")
              p2  (getpoint p1 "\n2nd point:")
        )
        (cond ((= 3 what_next) (setq rp  (- (nth 0 p2) (nth 0 p1))))
              ((= 4 what_next) (setq gp  (- (nth 1 p2) (nth 1 p1))))
              ((= 5 what_next) (setq ang (* 180 (/ (angle p1 p2) pi))))
        )
      )
      ((= what_next 6)
        (princ "\nQƃIuWFNgI:")
        (setq ents (ssget '((0 . "insert")))
              sp   0
              ep   (sslength ents)
              alist ""
        )
        (while (< sp ep)
          (setq ent   (entget (ssname ents sp))
                name  (cdr (assoc 2 ent))
                b     (- n (length (member name sellist)))
                alist (strcat alist " " (itoa b))
                sp    (1+ sp)
          )
        )  ; while end
        (setq sdata (if (= sdata "") (substr alist 2)
                                     (strcat sdata alist)))
      )
    ) ; cond end
  ) ; while end

  (unload_dialog dcl_id)

; ύXf[^Zbg -------------------------------------------------

  (setq dlist nil)
  (if sx  (setq dlist (cons (cons 41 sx) dlist)))
  (if sy  (setq dlist (cons (cons 42 sy) dlist)))
  (if sz  (setq dlist (cons (cons 43 sz) dlist)))
  (if ang (setq dlist (cons (cons 50 (setq ang (* pi (/ ang 180)))) dlist)))
  (if rn  (setq dlist (cons (cons 70 rn) dlist)))
  (if rp  (setq dlist (cons (cons 44 rp) dlist)))
  (if gn  (setq dlist (cons (cons 71 gn) dlist)))
  (if gp  (setq dlist (cons (cons 45 gp) dlist)))

; ҏWubNXg쐬 -------------------------------------------

  (if dlist ; ύXp[^Έȉs
    (progn

      (if (/= "" sdata)
        (progn
          (setq Blklist ""
                sdata (make_list sdata)
          )
          (foreach n sdata
            (setq Blklist (strcat Blklist "," (nth n sellist)))
          )
          (setq Blklist (substr Blklist 2))
          (setq flist (list '(0 . "insert")(cons 2 Blklist)))
        )
        (setq flist '((0 . "insert")))
      )

; ҏWubN̑I -----------------------------------------------

      (setq ents (ssget flist))

; f[^̕ύX ---------------------------------------------------------

      (setq ep (sslength ents)     ; vf
            sp 0)
      (while (< sp ep)
        (setq ent (entget (ssname ents sp)))

        ; Ύړx̏ꍇύXf[^̍ăZbg
        (if (and (= sc "1") (or sx sy sz))
          (progn
            (if sx (setq dm    (* sx (cdr (assoc 41 ent)))
                         dlist (subst (cons 41 dm) (assoc 41 dlist) dlist)
                   )
            )
            (if sy (setq dm    (* sy (cdr (assoc 42 ent)))
                         dlist (subst (cons 42 dm) (assoc 42 dlist) dlist)
                   )
            )
            (if sz (setq dm    (* sz (cdr (assoc 43 ent)))
                         dlist (subst (cons 43 dm) (assoc 43 dlist) dlist)
                   )
            )
          )
        )

        ; Ίpx̏ꍇύXf[^̍ăZbg
        (if (and (= sa "1") ang)
          (setq dm    (+ ang (cdr (assoc 50 ent)))
                dlist (subst (cons 50 dm) (assoc 50 dlist) dlist)
          )
        )

        (foreach n dlist
          (setq ent (subst n (assoc (car n) ent) ent ))
        )
        (entmod ent)
        (setq sp (1+ sp))
      )
    ) ; progn end
    (princ "\nύXp[^͂܂\n")
  ) ; if end

  (setvar "dimzin" dimzin)
  (princ)

)